/******************************************************************/
/* This file contains memory and I/O management definitions       */
/* $Id: parimemio.h,v 2.0.0.5 1998/02/07 16:17:00 karim Exp karim $ */

typedef unsigned char *byteptr;

typedef struct stackzone
{
  long zonetop, bot, top, avma, memused;
} stackzone;

typedef struct entree {
  char *name;
  ulong valence;
  void *value;
  long menu;
  char *code;
  struct entree *next;
  char *help;
  void *args;
} entree;

typedef struct PariOUT {
  void (*putch)(char);
  void (*puts)(char*);
  void (*flush)();
  void (*die)();
} PariOUT;

/* Common global variables: */

extern PariOUT *pariOut, *pariErr;
extern FILE    *outfile, *logfile, *infile, *errfile;

extern ulong avma,bot,top,memused;
extern GEN   RAVYZARC;

extern entree  **varentries;
extern char    *errmessage[], current_psfile[128];

extern byteptr diffptr;

/* This may not be exact on all machines [Ptitboul] */
#define is_universal_constant(x) \
  ((long)(x) >= (long)gzero && (long)(x)<=(long)gi)

#define copyifstack(x) (RAVYZARC=(GEN)(x),(RAVYZARC>=(GEN)bot && RAVYZARC<(GEN)top)?lcopy(RAVYZARC):(long)RAVYZARC)

#define gcopyifstack(x) (GEN)(copyifstack(x))
/* #define copyifstack(x) (lcopy((GEN)(x))) */
 
#ifdef __cplusplus
  inline int isonstack(GEN x)
  {
    GEN RAVYZARC=x;
    return (RAVYZARC>=(GEN)bot && RAVYZARC<(GEN)top);
  }
#else
# define isonstack(x) (\
    RAVYZARC=(GEN)(x),(RAVYZARC>=(GEN)bot && RAVYZARC<(GEN)top)\
  )
#endif

/* Define this to (1) locally (in a given file, NOT here) to check the global
 * "random" garbage collecting
 */
#ifdef DYNAMIC_STACK
#  define low_stack(x,l) (avma < (l))
#else
#  define low_stack(x,l) (avma < (x))
#endif

